set more off
cd U:\tf\Matteo\Rshock\Replication
use PANEL_DATASET, clear
adopath ++ .\ADOFILES
xtset country quarter
set scheme s1color



replace US_r = FFED

gen US_t = 0
gen d1_r = US_r-L1.US_r
gen d2_r = US_r-L2.US_r
gen d3_r = US_r-L3.US_r
gen d4_r = US_r-L4.US_r
gen f1_r = F1.US_r-US_r
gen f2_r = F2.US_r-US_r
gen f3_r = F3.US_r-US_r
gen f4_r = F4.US_r-US_r

replace US_t = US_r if d1_r>0 & d2_r>0.2  & d3_r>0.4  & tin(1965q1,2016q4)
replace US_t = US_r if d1_r>-0.3 & d2_r>-0.2 & d3_r>-0.1 & f1_r>-0.1 & f2_r>0.2 & f3_r>0.3 & tin(1965q1,2016q4)
replace US_t = US_r if d1_r>-0.3 & d2_r>-0.2 & d3_r>-0.1 & f1_r>-0.1 & f2_r>0.2 & f3_r>0.3 & tin(1965q1,2016q4)
replace US_t = US_r if f2_r>2 & f3_r>3.5
replace US_t = US_r if d3_r>1 & d4_r>2 & f2_r>1 & f3_r>0
replace US_t = 0 if L1.US_t==.

* Define tightening cycle as period in which US_t=US_r
datesof quarter if US_t==US_r

local t_ep = r(date_list)
di r(date_list)



gen US_tm = .
replace US_tm = US_t if US_t>0




gen rtaylor = 4 + 1.5*(US_dp-2) - (US_u-5)


 di r(date_list)

 
 
 
label var US_r "Fed Funds Rate"
label var US_tm "Monetary Tightening Episodes"

datesof quarter if US_t == US_r
local t_ep = r(date_list)
local c = 1
local str1a = "function y=20,range("
local str1b = "function y=1,range("
local str1c = "function y=6,range("
local str2a = ") recast(area) color(olive_teal) base(0) "
local str2b = ") recast(area) color(olive_teal) base(-1) "
local str2c = ") recast(area) color(olive_teal) base(0) "
local strc1 = ""
local strc2 = ""
local strc3 = ""

foreach ep of local t_ep{
			local qmax		= wordcount("`t_ep'")
			local t1 = substr("`ep'",2,6)
			local t2 = substr("`ep'",-7,6)
			local t1 = tq(`t1')
			local t2 = tq(`t2')
			local strc1 = "`strc1'" + "`str1a'" + "`t1' " + "`t2'" + "`str2a'"
			local strc2 = "`strc2'" + "`str1b'" + "`t1' " + "`t2'" + "`str2b'"
			local strc3 = "`strc3'" + "`str1c'" + "`t1' " + "`t2'" + "`str2c'"
			if `c' != `qmax' local strc1 = "`strc1' || "
			if `c' != `qmax' local strc2 = "`strc2' || "
			if `c' != `qmax' local strc3 = "`strc3' || "
		 }
local ++qmax



#delim ;
graph twoway `strc1' || 
tsline US_r if countrylong=="United States" & tin(1965q1,2016q4), 
xlabel(,format(%tq) tp(i)) 
lstyle(p4 p) 
lwidth(1 1) 
ylabel(,tp(i))
tlabel(1965q1(40)2016q4)
legend(off)
name(RU, replace) ;
#delim cr



gr export FIGURE1.pdf, mag(100) replace

