clear
set more off

local path    = "C:\Dropbox\Rshock\Replication"	// where files for regressions are


cls
cd `path'

adopath ++ `path'\ADOFILES
set scrollbufsize 300000

use datasetforplots, clear

set scheme s1color

label var auxvvf7     "Dollar Peg"
label var auxvvf8     "Trade with U.S."
label var auxvvfindex "Vulnerability Index"


// SAVE DATA
preserve 



replace countrylong = "UK" if countrylong == "United Kingdom"
replace countrylong = "US" if countrylong == "United States"
replace countrylong = "NewZealand" if countrylong == "New Zealand"
replace countrylong = "ElSalvador" if countrylong == "El Salvador"
replace countrylong = "SouthAfrica" if countrylong == "South Africa"
replace countrylong = "HongKong" if countrylong == "Hong Kong"
replace countrylong = "CzechRepublic" if countrylong == "Czech Republic"

local qin "1965q1"
local qfn "2016q4"
keep if tin( `qin' ,`qfn' ) 

rename  auxvvf7 Dollarpeg_
rename  auxvvf8 TradeUS_
rename  auxvvfindex Vuln_


keep Dollarpeg_ TradeUS_ Vuln_ quarter countrylong

gen yy = yofd(dofq(quarter)) 
gen qq = quarter(dofq(quarter)) 
gen yq = yy + (qq-1)/4

drop yy qq 

reshape wide Dollarpeg_ TradeUS_ Vuln_, i(yq) j(countrylong) string

cd `out_dir'
outsheet using FRAG_VARS_file_MS.csv, comma noquote replace
cd `path'

restore

